<?php
// Version: 2.2.1; SPortalBlocks

function template_portal_above()
{
	global $context, $modSettings;

	if (empty($modSettings['sp_disable_side_collapse']) && ((!empty($modSettings['showleft']) && !empty($context['SPortal']['blocks']['left'])) || (!empty($modSettings['showright']) && !empty($context['SPortal']['blocks']['right']))))
	{
		echo '
	<div class="sp_right sp_fullwidth">';

		if (!empty($modSettings['showleft']) && !empty($context['SPortal']['blocks']['left']))
			echo '
		<a href="#side" onclick="return sp_collapseSide(1)">', sp_embed_image($context['SPortal']['sides']['left']['collapsed'] ? 'expand' : 'collapse', '', null, null, true, 'sp_collapse_side1'), '</a>';

		if (!empty($modSettings['showright']) && !empty($context['SPortal']['blocks']['right']))
			echo '
		<a href="#side" onclick="return sp_collapseSide(4)">', sp_embed_image($context['SPortal']['sides']['right']['collapsed'] ? 'expand' : 'collapse', '', null, null, true, 'sp_collapse_side4'), '</a>';

		echo '
	</div>';
	}

	echo '
	<table id="sp_main">
		<tr>';

	if (!empty($modSettings['showleft']) && !empty($context['SPortal']['blocks']['left']))
	{
		echo '
			<td id="sp_left"', !empty($modSettings['leftwidth']) ? ' width="' . $modSettings['leftwidth'] . '"' : '', $context['SPortal']['sides']['left']['collapsed'] && empty($modSettings['sp_disable_side_collapse']) ? ' style="display: none;"' : '', '>';

		foreach ($context['SPortal']['blocks']['left'] as $block)
			template_block($block);

		echo '
			</td>';
	}

	echo '
			<td id="sp_center">';

	foreach ($context['SPortal']['blocks']['top'] as $block)
		template_block($block);
}

function template_portal_below()
{
	global $context, $modSettings;

	echo '
				<br />';

	foreach ($context['SPortal']['blocks']['bottom'] as $block)
		template_block($block);

	echo '
			</td>';

	if (!empty($modSettings['showright']) && !empty($context['SPortal']['blocks']['right'])) 
	{
		echo '
			<td id="sp_right"', !empty($modSettings['rightwidth']) ? ' width="' . $modSettings['rightwidth'] . '"' : '', $context['SPortal']['sides']['right']['collapsed'] && empty($modSettings['sp_disable_side_collapse']) ? ' style="display: none;"' : '', '>';

		foreach ($context['SPortal']['blocks']['right'] as $block)
			template_block($block);

		echo '
			</td>';
	}
	echo '
		</tr>
	</table>';
}

function template_block($block)
{
	global $settings;

	if ($block['type'] == 'sp_boardNews')
	{
		$block['type']($block['parameters'], $block['id']);

		return;
	}

	if (!empty($block['style']) && !is_array($block['style']))
	{
		$temp = explode('|', $block['style']);
		$block['style'] = array();

		foreach ($temp as $style)
		{
			list ($key, $value) = explode('~', $style);
			$block['style'][$key] = $value;
		}
	}
	elseif (!is_array($block['style']))
	{
		$block['style'] = array(
			'title_default_class' => 'catbg',
			'title_custom_class' => '',
			'title_custom_style' => '',
			'body_default_class' => 'windowbg',
			'body_custom_class' => '',
			'body_custom_style' => '',
			'no_title' => false,
			'no_body' => false,
		);
	}

	if (empty($block['style']['no_title']))
	{
		$block['style']['title']['class'] = $block['style']['title_default_class'];

		if (!empty($block['style']['title_custom_class']))
			$block['style']['title']['class'] .= ' ' . $block['style']['title_custom_class'];

		$block['style']['title']['style'] = $block['style']['title_custom_style'];
	}

	if (empty($block['style']['no_body']))
		$block['style']['body']['class'] = $block['style']['body_default_class'];
	else
		$block['style']['body']['class'] = '';

	if (!empty($block['style']['body_custom_class']))
		$block['style']['body']['class'] .= ' ' . $block['style']['body_custom_class'];

	$block['style']['body']['style'] = $block['style']['body_custom_style'];

	echo '
				<div', !empty($block['style']['no_body']) ? '' : ' class="tborder"', '>
					<table class="sp_block">';

	if (empty($block['style']['no_title']))
	{
		echo '
						<tr>
							<td class="sp_block_padding ', $block['style']['title']['class'], '"', !empty($block['style']['title']['style']) ? ' style="' . $block['style']['title']['style'] . '"' : '', '>';

		if (empty($block['force_view']))
			echo '
								<a class="sp_float_right" href="javascript:void(0);" onclick="sp_collapseBlock(\'', $block['id'], '\')"><img id="sp_collapse_', $block['id'], '" src="', $settings['images_url'], $block['collapsed'] ? '/expand.gif' : '/collapse.gif', '" alt="*" /></a>';

		echo '
								', parse_bbc($block['label']), '
							</td>
						</tr>';
	}

	echo '
						<tr', (empty($block['force_view']) ? ' id="sp_block_' . $block['id'] . '"' : '') , $block['collapsed'] && empty($block['force_view']) ? ' style="display: none;"' : '', '>
							<td class="sp_block_padding', empty($block['style']['body']['class']) ? '' : ' ' . $block['style']['body']['class'], '"', !empty($block['style']['body']['style']) ? ' style="' . $block['style']['body']['style'] . '"' : '', '>';

	$block['type']($block['parameters'], $block['id']);

	echo '
							</td>
						</tr>
					</table>
				</div>
				<br />';
}

?>