<?php
/**********************************************************************************
* Subs-SPortal1-1.php                                                             *
***********************************************************************************
* SimplePortal                                                                    *
* SMF Modification Project Founded by [SiNaN] (sinan@simplemachines.org)          *
* =============================================================================== *
* Software Version:           SimplePortal 2.2.1                                  *
* Software by:                SimplePortal Team (http://www.simpleportal.net)     *
* Copyright 2008-2009 by:     SimplePortal Team (http://www.simpleportal.net)     *
* Support, News, Updates at:  http://www.simpleportal.net                         *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the provided license as published by Simple Machines LLC.          *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* See the "license.txt" file for details of the Simple Machines license.          *
* The latest version can always be found at http://www.simplemachines.org.        *
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

/*
	array getBlockInfo()
		// !!!

	bool getShowInfo()
		// !!!

	array getFunctionInfo()
		// !!!

	array getCategoryInfo()
		// !!!

	array getArticleInfo()
		// !!!

	void createArticle()
		// !!!

	void fixCategoryArticles()
		// !!!

	void fixColumnRows()
		// !!!

	void changeBlockRow()
		// !!!

	void changeState()
		// !!!

	bool sp_loadPermissions()
		// !!!

	bool spAllowedTo()
		// !!!

	void sp_loadMembergroups()
		// !!!

	bool sp_validate_php()
		// !!!

	array loadDatabaseTables()
		// !!!

	bool databaseTableExists()
		// !!!

	array sp_loadCalendarData()
		// !!!

	void sp_loadColors()
		// !!!

	string sp_embed_image()
		// !!!
*/

function getBlockInfo($column_id = null, $block_id = null, $state = null, $show = null)
{
	global $db_prefix, $context, $settings, $options, $txt;

	$query = array();
	if(!empty($column_id))
		$query[] = "spb.col = '$column_id'";
	if(!empty($block_id))
		$query[] = "spb.ID_BLOCK = '$block_id'";
	if(!empty($state))
		$query[] = "spb.state = 1";

	$request = db_query("
		SELECT
			spb.ID_BLOCK, spb.label, spb.type, spb.col, spb.row, spb.state,
			spb.force_view, spb.allowed_groups, spb.permission_type, spb.display,
			spb.display_custom, spb.style, spp.variable, spp.value
		FROM {$db_prefix}sp_blocks AS spb
			LEFT JOIN {$db_prefix}sp_parameters AS spp ON (spp.ID_BLOCK = spb.ID_BLOCK)" . (!empty($query) ? "
		WHERE " . implode(' AND ', $query) : "") . "
		ORDER BY spb.row", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{
		if (!empty($show) && !getShowInfo($row['ID_BLOCK'], $row['display'], $row['display_custom']))
			continue;

		if (!spAllowedTo('block', $row['ID_BLOCK']))
			continue;

		if (!isset($return[$row['ID_BLOCK']]))
		{
			$return[$row['ID_BLOCK']] = array(
				'id' => $row['ID_BLOCK'],
				'label' => $row['label'],
				'type' => $row['type'],
				'type_text' => !empty($txt['sp_function_' . $row['type'] . '_label']) ? $txt['sp_function_' . $row['type'] . '_label'] : $txt['sp_function_unknown_label'],
				'column' => $row['col'],
				'row' => $row['row'],
				'state' => empty($row['state']) ? 0 : 1,
				'force_view' => $row['force_view'],
				'allowed_groups' => $row['allowed_groups'],
				'permission_type' => $row['permission_type'],
				'display' => $row['display'],
				'display_custom' => $row['display_custom'],
				'style' => $row['style'],
				'collapsed' => $context['user']['is_guest'] ? !empty($_COOKIE['sp_block_' . $row['ID_BLOCK']]) : !empty($options['sp_block_' . $row['ID_BLOCK']]),
				'parameters' => array(),
			);
		}

		if (!empty($row['variable']))
			$return[$row['ID_BLOCK']]['parameters'][$row['variable']] = $row['value'];
	}
	mysql_free_result($request);

	return $return;
}

// Function to get a block's display/show information.
function getShowInfo($block_id = null, $display = null, $custom = null)
{
	global $db_prefix, $context, $modSettings;

	// Do we have the display info?
	if ($display === null || $custom === null)
	{
		// Make sure that its an integer.
		$block_id = (int) $block_id;

		// We need an ID.
		if (empty($block_id))
			return false;

		// Get the info.
		$request = db_query("
			SELECT display, display_custom
			FROM {$db_prefix}sp_blocks
			WHERE ID_BLOCK = $block_id
			LIMIT 1", __FILE__, __LINE__);
		list ($display, $custom) = mysql_fetch_row($request);
		mysql_free_result($request);
	}

	// Some variables for ease.
	$action = !empty($context['current_action']) ? $context['current_action'] : '';
	$board = !empty($context['current_board']) ? $context['current_board'] : '';
	$portal = (empty($action) && empty($board) && SMF != 'SSI' && $modSettings['sp_portal_mode'] == 1) || !empty($context['standalone']) ? true : false;

	// Will hopefully get larger in the future.
	$portal_actions = array(
		'sa' => array('news', 'articles'),
		'start' => true,
		'theme' => true,
		'PHPSESSID' => true,
		'wwwRedirect' => true,
		'www' => true,
		'variant' => true,
		'language' => true,
	);

	// Set some action exceptions.
	$exceptions = array(
		'post' => array('announce', 'editpoll', 'post2', 'sendtopic'),
		'register' => array('activate', 'coppa'),
		'forum' => array('collapse'),
		'admin' => array('credits', 'theme', 'viewquery', 'admin', 'ban', 'boardrecount', 'cleanperms', 'detailedversion', 'dumpdb', 'featuresettings', 'featuresettings2', 'findmember', 'maintain', 'manageattachments', 'manageboards', 'managecalendar', 'managesearch', 'membergroups', 'modlog', 'news', 'optimizetables', 'packageget', 'packages', 'permissions', 'pgdownload', 'postsettings', 'regcenter', 'repairboards', 'reports', 'serversettings', 'serversettings2', 'smileys', 'viewErrorLog', 'viewmembers', 'spadmin'),
		'login' => array('reminder'),
		'profile' => array('trackip', 'viewprofile'),
	);

	// Still, we might not be in portal!
	if (!empty($_GET) && empty($context['standalone']))
		foreach ($_GET as $key => $value)
			if (!isset($portal_actions[$key]))
				$portal = false;
			elseif (is_array($portal_actions[$key]) && !in_array($value, $portal_actions[$key]))
				$portal = false;

	// Set the action to more known one.
	foreach ($exceptions as $key => $exception)
		if (in_array($action, $exception))
			$action = $key;

	// Take care of custom actions.
	$special = array();
	$exclude = array();
	if (!empty($custom))
	{
		$custom = explode(', ', $custom);

		// This is special...
		foreach ($custom as $key => $value)
		{
			$name = '';
			$item = '';

			// Is this a weird action?
			if ($value[0] == '~')
			{
				@list($name, $item) = explode('|', substr($value, 1));

				if (empty($item))
					$special[$name] = true;
				else
					$special[$name][] = $item;
			}

			// Might be excluding something!
			elseif ($value[0] == '-')
			{
				// We still may have weird things...
				if ($value[1] == '~')
				{
					@list($name, $item) = explode('|', substr($value, 2));

					if (empty($item))
						$exclude['special'][$name] = true;
					else
						$exclude['special'][$name][] = $item;
				}
				else
					$exclude['regular'][] = substr($value, 1);
			}
		}

		// Add what we have to main variable.
		if (!empty($display))
			$display = $display . ', ' . implode(', ', $custom);
		else
			$display = $custom;
	}

	// We don't want to show it in this action?
	if (!empty($exclude['regular']) && !empty($action) && in_array($action, $exclude['regular']))
		return false;

	// Maybe we don't want to show it in somewhere special.
	if (!empty($exclude['special']))
		foreach ($exclude['special'] as $key => $value)
			if (isset($_GET[$key]))
				if (is_array($value) && !in_array($_GET[$key], $value))
					continue;
				else
					return false;

	// If no display info and/or integration disabled and we are on portal; show it!
	if ((empty($display) || empty($modSettings['sp_enableIntegration'])) && $portal)
		return true;
	// No display info and/or integration disabled and no portal; no need...	
	elseif (empty($display) || empty($modSettings['sp_enableIntegration']))
		return false;
	// Get ready for real action if you haven't yet.
	elseif (!is_array($display))
		$display = explode(', ', $display);

	// Did we disable all blocks for this action?
	if (!empty($modSettings['sp_' . $action . 'IntegrationHide']))
		return false;
	// If we will display show the block.
	elseif (in_array('all', $display))
		return true;
	// If we are on portal, show portal blocks; if we are on forum, show forum blocks.
	elseif (($portal && (in_array('portal', $display) || in_array('sportal', $display))) || (!$portal && in_array('sforum', $display)))
		return true;
	// If current action or board is in display info; or we should display block in all actions or all boards then you can display block.
	elseif ((!empty($action) && (in_array('allaction', $display) || in_array($action, $display))) || ((empty($action) || $action == 'forum' || in_array($action, $display)) && !empty($board) && (in_array('allboard', $display) || in_array($board, $display))))
		return true;

	// For mods using weird urls...
	foreach ($special as $key => $value)
		if (isset($_GET[$key]))
			if (is_array($value) && !in_array($_GET[$key], $value))
				continue;
			else
				return true;

	// Ummm, no block!
	return false;
}

function getFunctionInfo($function = null)
{
	global $db_prefix;

	$request = db_query("
		SELECT ID_FUNCTION, name, parameter
		FROM {$db_prefix}sp_functions" . (!empty($function) ? "
			WHERE name = '$function'" : "") . "
		ORDER BY function_order", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{
		//There is one function who is not allowed to use by non admins
		if ($row['name'] == 'sp_php' && !allowedTo('admin_forum'))
			continue;

		$return[] = array(
			'id' => $row['ID_FUNCTION'],
			'function' => $row['name'],
			'parameter' => $row['parameter'],
		);
	}
	mysql_free_result($request);

	return $return;
}

function getCategoryInfo($category_id = null)
{
	global $scripturl, $context, $db_prefix, $settings, $txt;

	$request = db_query("
		SELECT ID_CATEGORY, name, picture, articles, publish
		FROM {$db_prefix}sp_categories" . (!empty($category_id) ? "
		WHERE ID_CATEGORY = '$category_id'" : "") . "
		ORDER BY ID_CATEGORY", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$return[] = array(
			'id' => $row['ID_CATEGORY'],
			'name' => $row['name'],
			'picture' => array (
				'href' => $row['picture'],
				'image' => '<img src="' . $row['picture'] . '" alt="' . $row['name'] . '" width="75" />',
			),
			'articles' => $row['articles'],
			'publish' => $row['publish'],
		);
	}
	mysql_free_result($request);

	return $return;
}

function getArticleInfo($article_id = null, $category_id = null, $message_id = null, $approved = null)
{
	global $db_prefix;

	$query = array();
	if(!empty($article_id))
		$query[] = "ID_ARTICLE = '$article_id'";
	if(!empty($category_id))
		$query[] = "ID_CATEGORY = '$category_id'";
	if(!empty($message_id))
		$query[] = "ID_MESSAGE = '$message_id'";
	if(!empty($approved))
		$query[] = "approved = '1'";

	$request = db_query("
		SELECT a.ID_ARTICLE, a.ID_CATEGORY, a.ID_MESSAGE, a.approved, c.name
		FROM {$db_prefix}sp_articles as a
			LEFT JOIN {$db_prefix}sp_categories AS c ON (c.ID_CATEGORY = a.ID_CATEGORY)" . (!empty($query) ? "
		WHERE " . implode(' AND ', $query) : "") . "
		ORDER BY ID_ARTICLE", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$return[] = array(
			'article' => array(
				'id' => $row['ID_ARTICLE'],
				'approved' => $row['approved'],
			),
			'category' => array(
				'id' => $row['ID_CATEGORY'],
				'name' => $row['name'],
			),
			'message' => array(
				'id' => $row['ID_MESSAGE'],
			),
		);
	}
	mysql_free_result($request);

	return $return;
}

function createArticle($articleOptions)
{
	global $db_prefix;

	$articleOptions['ID_CATEGORY'] = !empty($articleOptions['ID_CATEGORY']) ? (int) $articleOptions['ID_CATEGORY'] : 0;
	$articleOptions['ID_MESSAGE'] = !empty($articleOptions['ID_MESSAGE']) ? (int) $articleOptions['ID_MESSAGE'] : 0;
	$articleOptions['approved'] = !empty($articleOptions['approved']) ? (int) $articleOptions['approved'] : 0;

	$request = db_query("
		SELECT ID_MESSAGE
		FROM {$db_prefix}sp_articles
		WHERE ID_MESSAGE = '$articleOptions[ID_MESSAGE]'
		LIMIT 1", __FILE__, __LINE__);
	list ($exists) = mysql_fetch_row($request);
	mysql_free_result($request);		

	if (empty($articleOptions['ID_CATEGORY']) || empty($articleOptions['ID_MESSAGE']) || $exists)
		return false;

	db_query("
		INSERT INTO {$db_prefix}sp_articles
			(ID_CATEGORY, ID_MESSAGE, approved)
		VALUES ('$articleOptions[ID_CATEGORY]', '$articleOptions[ID_MESSAGE]', $articleOptions[approved])", __FILE__, __LINE__);

	db_query("
		UPDATE {$db_prefix}sp_categories
		SET articles = articles + 1
		WHERE ID_CATEGORY = $articleOptions[ID_CATEGORY]
		LIMIT 1", __FILE__, __LINE__);
}

function fixCategoryArticles()
{
	global $db_prefix;

	$categoryList = getCategoryInfo();
	$category_ids = array();	

	foreach ($categoryList as $category)
		$category_ids[] = $category['id'];

	foreach($category_ids as $category)
	{
		$article_count = 0;

		$result = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}sp_articles
			WHERE ID_CATEGORY = $category", __FILE__, __LINE__);
		list ($article_count) = mysql_fetch_row($result);
		mysql_free_result($result);

		db_query("
			UPDATE {$db_prefix}sp_categories
			SET articles = $article_count
			WHERE ID_CATEGORY = $category
			LIMIT 1", __FILE__, __LINE__);
	}
}

function fixColumnRows($column_id = null)
{
	global $db_prefix;

	$blockList = getBlockInfo($column_id);
	$block_ids = array();	

	foreach ($blockList as $block)
		$block_ids[] = $block['id'];

	$counter = 0;

	foreach($block_ids as $block)
	{
		$counter = $counter + 1;

		db_query("
			UPDATE {$db_prefix}sp_blocks
			SET row = $counter
			WHERE ID_BLOCK = $block
			LIMIT 1", __FILE__, __LINE__);
	}
}

function changeBlockRow($block_id = null, $direction = null)
{
	global $db_prefix;

	$blockInfo = current(getBlockInfo(null, $block_id));

	db_query("
		UPDATE {$db_prefix}sp_blocks
		SET row = $blockInfo[row]
		WHERE row = $blockInfo[row] " . ($direction == 'up' ? "-" : "+") . " 1
			AND col = $blockInfo[column]
		LIMIT 1", __FILE__, __LINE__);

	db_query("
		UPDATE {$db_prefix}sp_blocks
		SET row = row " . ($direction == 'up' ? "-" : "+") . " 1
		WHERE ID_BLOCK = $block_id
			AND col = $blockInfo[column]
		LIMIT 1", __FILE__, __LINE__);
}

function changeState($type = null, $id = null)
{
	global $db_prefix;

	if ($type == 'block')
		$query = array(
			'column' => 'state',
			'table' => 'blocks',
			'id' => 'ID_BLOCK'
		);
	elseif ($type == 'category')
		$query = array(
			'column' => 'publish',
			'table' => 'categories',
			'id' => 'ID_CATEGORY'
		);
	elseif ($type == 'article')
		$query = array(
			'column' => 'approved',
			'table' => 'articles',
			'id' => 'ID_ARTICLE'
		);
	else
		return false;
	
	$request = db_query("
		SELECT $query[column]
		FROM {$db_prefix}sp_$query[table]
		WHERE $query[id] = $id
		LIMIT 1", __FILE__, __LINE__);
	list ($state) = mysql_fetch_row($request);
	mysql_free_result($request);

	$state = (int) $state;
	$state = $state == 1 ? 0 : 1 ;

	db_query("
		UPDATE {$db_prefix}sp_$query[table]
		SET $query[column] = $state
		WHERE $query[id] = $id
		LIMIT 1", __FILE__, __LINE__);
}

// Make the allowed check faster, because i can cache this data!
// force_view is used for the way to make 3 diffrent ways to check blocks!
function sp_loadPermissions($type = null)
{
	global $db_prefix, $sp_context, $user_info;

	// Checkup
	if (empty($type) || !in_array($type, array('block', 'article'))) 
		return false;

	// Prevent double load :)	
	if (!isset($sp_context['permissions'][$type]))
		$sp_context['permissions'][$type] = array();
	else
		return !empty($sp_context['permissions'][$type]); //On false allowed to nothing ;P

	// Blockquery Informations :)
	if($type == 'block')
	{
		// Get the necessary block information.
		$request = db_query("
			SELECT allowed_groups AS allowed_groups, id_block AS id, permission_type
			FROM {$db_prefix}sp_blocks
			WHERE (permission_type = 2 
			OR (FIND_IN_SET(" . implode(', allowed_groups) OR FIND_IN_SET(', $user_info['groups']) . ", allowed_groups)))", __FILE__, __LINE__);
	}
	else
	{
		// Get the necessary block information.
		$request = db_query("
			SELECT allowed_groups AS allowed_groups, id_article AS id
			FROM {$db_prefix}sp_articles
			WHERE (FIND_IN_SET(" . implode(', allowed_groups) OR FIND_IN_SET(', $user_info['groups']) . ", allowed_groups))", __FILE__, __LINE__);
	}

	// The output will only show the allowed positions ;D
	while($row = mysql_fetch_assoc($request))
	{
		// This Permission need a extra checkup 8), it's a faster query now, a lot faster!
		if (!empty($row['permission_type']) && $row['permission_type'] == 1)
		{
			if (count(array_intersect($user_info['groups'], explode(',', $row['allowed_groups']))) != count($user_info['groups']))
				continue;
		}
		$sp_context['permissions'][$type][$row['id']] = $row['id'];
	}
	mysql_free_result($request);

	// Okay chached it ;) now it should be faster... a lot faster 8)
	return !empty($sp_context['permissions'][$type]);
}

// Function to check if users are allowed to view certain blocks.
function spAllowedTo($type = null, $id = null)
{
	global $sp_context;

	// SP moderators are supermen. :D i need to do nothing if this correct! It's to late checked!
	// And this is the reason why admin unselect never work!
	// If we like to fix this we need to think about a way to allowed it in a other way or insert a force admin check
	if (allowedTo('sp_moderate'))
		return true;
	// Sanitize the ID.
	$id = (int) $id;
	// Make sure that we have a proper id, load Permissions and store a chache 
	if (empty($id) || sp_loadPermissions($type) === false || empty($type))
		return false;
	//Pah if it isset than you allowed, if not than not :)
	return isset($sp_context['permissions'][$type][$id]);
}

/*
	void sp_loadMemberGroups(Array $selectedGroups = array, Array $removeGroups = array(), string $show = 'normal', string $contextName = 'member_groups')
	This will file the $context['member_groups'] to the given options
	$selectedGroups means all groups who should be shown as selcted, if you like to check all than insert an 'all'
		You can also Give the function a string with '2,3,4'
	$removeGroups this group id should not shown in the list
	$show have follow options
		'normal' => will show all groups, and add a guest and regular member (Standard)
		'post' => will load only post groups
		'master' => will load only not postbased groups
	$contextName where the datas should stored in the $context;

	The Administrator group id 1 will evertime ignored!
*/
function sp_loadMemberGroups($selectedGroups = array(), $show = 'normal', $contextName = 'member_groups')
{
	global $db_prefix, $context, $smcFunc, $txt;
	
	// Some additional Language stings are needed
	loadLanguage('ManageBoards');

	// Make sure its empty
	$context[$contextName] = array();
	
	// Preseting some things :)
	if (!is_array($selectedGroups))
		$checked = strtolower($selectedGroups) == 'all';
	else
		$checked = false;

	if (!$checked && !empty($selectedGroups))
	{
		if (!is_array($selectedGroups)) 
			$selectedGroups = explode(',', $selectedGroups);

		// Remove all strings, i will only allowe ids :P
		foreach ($selectedGroups as $k => $i)
			$selectedGroups[$k] = (int) $i;

		$selectedGroups = array_unique($selectedGroups);
	}
	else
		$selectedGroups = array();

	// Okay let's checkup the show function
	$show_option = array(
		'normal' => 'ID_GROUP != 1',
		'post' => 'minPosts != -1',
		'master' => 'minPosts = -1 AND ID_GROUP != 1',
	);
	$show = strtolower($show);

	if (!isset($show_option[$show]))
		$show = 'normal';

	// Guest and Members are added manually. Only on normal ond master View =)
	if($show == 'normal' || $show == 'master')
	{
		$context[$contextName][-1] = array(
			'id' => -1,
			'name' => $txt['membergroups_guests'],
			'checked' => $checked || in_array(-1, $selectedGroups),
			'is_post_group' => false,
		);
		$context[$contextName][0] = array(
			'id' => 0,
			'name' => $txt['membergroups_members'],
			'checked' => $checked || in_array(0, $selectedGroups),
			'is_post_group' => false,
		);
	}

	// Load membergroups.
	$request = db_query("
		SELECT groupName, ID_GROUP, minPosts
		FROM {$db_prefix}membergroups
		WHERE ".$show_option[$show]."
		ORDER BY minPosts, ID_GROUP != 2, groupName",__FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		$context[$contextName][(int) $row['ID_GROUP']] = array(
			'id' => $row['ID_GROUP'],
			'name' => trim($row['groupName']),
			'checked' => $checked || in_array($row['ID_GROUP'], $selectedGroups),
			'is_post_group' => $row['minPosts'] != -1,
		);
	}
	mysql_free_result($request);
}

function sp_query_string($tourniquet)
{
	global $sportal_version, $context;
	static $initialized;

	if ((SMF == 'SSI' && empty($context['standalone'])) || empty($context['template_layers']) || WIRELESS || $initialized)
		return $tourniquet;

	$fix = str_replace('{version}', $sportal_version, '<a href="http://www.simpleportal.net/" target="_blank">SimplePortal {version} &copy; 2008-2009</a>');

	$tourniquet = preg_replace(base64_decode('figsIFNpbXBsZSBNYWNoaW5lcyBMTEM8L2E+KX4='), base64_decode('LCBTaW1wbGUgTWFjaGluZXMgTExDPC9hPjxiciAvPg==') . $fix, $tourniquet);

	if (strpos($tourniquet, $fix) === false)
	{
		$fix = '<div style="text-align: center; width: 100%; font-size: x-small; margin-bottom: 5px;">' . $fix . '</div></body></html>';
		$tourniquet = preg_replace('~</body>\s*</html>~', $fix, $tourniquet);
	}

	$initialized = true;

	return $tourniquet;
}

// Makes sure that PHP is valid.
function sp_validate_php($code)
{
	global $boardurl, $boarddir, $sourcedir;

	$id = time();
	$error = false;
	$filename = 'sp_tmp_' . $id . '.php';
	$temp_dir = $boarddir . '/Packages/temp';
	$temp_url = $boardurl . '/Packages/temp';

	$code = trim($code);
	$code = trim($code, '<?php');
	$code = trim($code, '?>');

	require_once($sourcedir . '/Subs-Package.php');

	if (file_exists($temp_dir))
		deltree($temp_dir, false);

	if (!mktree($temp_dir, 0755))
	{
		deltree($temp_dir, false);

		if (!mktree($temp_dir, 0777))
			return false;
	}

	$content = '<?php

require_once(\'' . $boarddir . '/SSI.php\');

' . $code . '

?>';

	$fp = fopen($temp_dir . '/' . $filename, 'w');
	fwrite($fp, $content);
	fclose($fp);

	if (!file_exists($temp_dir . '/' . $filename))
		return false;

	$result = fetch_web_data($temp_url . '/' . $filename);

	if ($result === false)
		$error = 'database';
	elseif (preg_match('~ <b>(\d+)</b><br( /)?' . '>$~i', $result) != 0)
		$error = 'syntax';

	unlink($temp_dir . '/' . $filename);

	return $error;
}

/*
	bool loadDatabaseTables ()
	- Preload database Tables this will be only done once per script call
	- Return false on error
	- Mysql 3.x+ Compatible ;) for SMF 1.1.x
*/
function loadDatabaseTables()
{
	global $database_tables, $db_name;

	if (isset($database_tables))
		return !empty($database_tables);
	else
		$database_tables = array();

	// Prepare a Checkup ;D
	$request = db_query("
		SHOW TABLES
		FROM `{$db_name}`", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
		$database_tables[] = strtolower(current($row));
	mysql_free_result($request);

	return !empty($database_tables);
}

/*
	bool databaseTableExists (string tablename, bool $addprefix = true)
	- Work only in SMF 1.1.x (SMF 2.0.x work diffrent, but it's possible to insert)
	- Return true if the tablename exits
	- $addprefix will automatic add the $db_prefix (Check also it this is allready done!)
*/
function databaseTableExists($tablename = '', $addprefix = true)
{
	global $database_tables, $db_prefix;
	
	// Nothing to Serach for ;)
	if (empty($tablename))
		return false;

	// Error ?_?
	if (empty($database_tables) && !loadDatabaseTables())
		return false;

	// First thing i do.. i know normal i should not so this ;P But it's good enouph for smf ;)
	$tablename = strtolower($tablename);

	// Table Prefix auto add? :D
	if ($addprefix === true && strpos($tablename, $db_prefix) !== 0)
	{
		// Looks not so nice ;) but it work trust me ;P
		if (strpos($tablename, '{$db_prefix}') !== false)
			$tablename = str_replace('{$db_prefix}', $db_prefix, $tablename);
		elseif (strpos($tablename, '$db_prefix') !== false)
			$tablename = str_replace('$db_prefix', $db_prefix, $tablename);
		else
			$tablename = $db_prefix.$tablename;
	}

	return in_array($tablename, $database_tables);
}

// This function return the correct array that is called.
function sp_loadCalendarData($type, $low_date, $high_date = false)
{
	global $sourcedir;
	static $loaded;

	if (!isset($loaded))
	{
		require_once($sourcedir . '/Calendar.php');

		$loaded = array(
			'getEvents' => 'calendarEventArray',
			'getBirthdays' => 'calendarBirthdayArray',
			'getHolidays' => 'calendarHolidayArray',
		);
	}
	if (!empty($loaded[$type]))
		return $loaded[$type]($low_date, ($high_date === false ? $low_date : $high_date));
	else
		return array();
}

function sp_startElement($parser, $name, $attrs)
{
	global $rss_data, $rss_current, $rss_main;

	switch($name)
	{
		case 'RSS':
		case 'RDF:RDF':
		case 'ITEMS':
			$rss_current = '';
			break;
		case 'CHANNEL':
			$rss_main = 'CHANNEL';
			break;
		case 'IMAGE':
			$rss_main = 'IMAGE';
			$rss_data['IMAGE'] = array();
			break;
		case 'ITEM':
			$rss_main = 'ITEMS';
			break;
		default:
			$rss_current = $name;
			break;
	}
}

function sp_endElement($parser, $name)
{
	global $rss_data, $rss_current, $rss_counter;

	$rss_current = '';

	if ($name == 'ITEM')
		$rss_counter++;
}

function sp_characterData($parser, $data)
{
	global $rss_data, $rss_current, $rss_main, $rss_counter;

	if (!empty($rss_current))
	{
		switch($rss_main)
		{
			case 'CHANNEL':
				if (isset($rss_data[$rss_current]))
					$rss_data[$rss_current] .= $data;
				else
					$rss_data[$rss_current] = $data;
				break;
			case 'IMAGE':
				if (isset($rss_data[$rss_main][$rss_current]))
					$rss_data[$rss_main][$rss_current] .= $data;
				else
					$rss_data[$rss_main][$rss_current] = $data;
				break;
			case 'ITEMS':
				if (isset($rss_data[$rss_main][$rss_counter][$rss_current]))
					$rss_data[$rss_main][$rss_counter][$rss_current] .= $data;
				else
					$rss_data[$rss_main][$rss_counter][$rss_current] = $data;
				break;
		}
	}
}

// This is a small script to load colors for SPortal.
function sp_loadColors($users = array()) 
{
	global $color_profile, $scripturl, $modSettings, $db_prefix;

	// This is for later, if you like to disable colors ;)
	if (!empty($modSettings['sp_disableColor']))
		return false;

	// Can't just look for no users. :P
	if (empty($users))
		return false;

	// MemberColorLink compatible, chache more data, handle also some special member color link colors
	if (!empty($modSettings['MemberColorLinkInstalled']))
	{
		$colorDatas = load_onlineColors($users);
		$loaded_ids = array_keys($colorDatas);

		foreach($loaded_ids as $id)
		{
			if(!empty($id) && !isset($color_profile[$id]['link']))
			{
				$color_profile[$id]['link'] = $colorDatas[$id]['colored_link'];
				$color_profile[$id]['colored_name'] = $colorDatas[$id]['colored_name'];
			}
		}
		return empty($loaded_ids) ? false : $loaded_ids;
	}

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);

	// Check up the array :)
	foreach($users as $k => $u)
	{
		$u = (int) $u;
		if(empty($u))
			unset($users[$k]);
		else
			$users[$k] = $u;
	}

	$loaded_ids = array();
	// Is this a totally new variable?
	if (empty($color_profile))
		$color_profile = array();
	// Otherwise, we will need to do some reformating of the old data.
	else 
	{
		foreach($users as $k => $u)
			if(isset($color_profile[$u]))
			{
				$loaded_ids[] = $u;
				unset($users[$k]);
			}
	}

	// Make sure that we have some users.
	if (empty($users))
		return empty($loaded_ids) ? false : $loaded_ids;

	// Load the data.
	$request = db_query("
		SELECT 
			mem.ID_MEMBER, mem.memberName, mem.realName, mem.ID_GROUP,
			mg.onlineColor AS member_group_color, pg.onlineColor AS post_group_color
		FROM {$db_prefix}members AS mem 
		LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
		LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
		WHERE mem.ID_MEMBER ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"), __FILE__, __LINE__);

	// Go through each of the users.
	while ($row = mysql_fetch_assoc($request))
	{
		$loaded_ids[] = $row['ID_MEMBER'];
		$color_profile[$row['ID_MEMBER']] = $row;
		$onlineColor = !empty($row['member_group_color']) ? $row['member_group_color'] : $row['post_group_color'];
		$color_profile[$row['ID_MEMBER']]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '"' . (!empty($onlineColor) ? ' style="color: ' . $onlineColor . ';"' : '') . '>' . $row['realName'] . '</a>';
		$color_profile[$row['ID_MEMBER']]['colored_name'] = (!empty($onlineColor) ? '<span style="color: ' . $onlineColor . ';">' : '' ) . $row['realName'] . (!empty($onlineColor) ? '</span>' : '');
	}
	mysql_free_result($request);

	// Return the necessary data.
	return empty($loaded_ids) ? false : $loaded_ids;
}

function sp_embed_image($name, $alt = '', $width = null, $height = null, $title = true, $id = null)
{
	global $modSettings, $settings, $txt;
	static $default_alt, $randomizer;

	if (!isset($default_alt))
	{
		$default_alt = array(
			'dot' => $txt['sp-dot'],
			'arrow' => $txt['sp-arrow'],
			'modify' => $txt[17],
			'delete' => $txt['smf138'],
		);
	}

	if (!isset($randomizer) || $randomizer > 7)
		$randomizer = 0;
	$randomizer++;

	if (empty($alt) && isset($default_alt[$name]))
		$alt = $default_alt[$name];

	if ($title === true)
		$title = !empty($alt) ? $alt : '';

	if (empty($alt))
		$alt = $name;

	if ($name == 'dot' && empty($modSettings['sp_disable_random_bullets']))
		$name = 'dot' . $randomizer;
	elseif ($name == 'dot')
		$name = 'dot1';

	$image = '<img src="' . $settings['sp_images_url'] . '/' . $name . '.png" alt="' . $alt . '"' . (!empty($title) ? ' title="' . $title . '"' : '') . (!empty($width) ? ' width="' . $width . '"' : '') . (!empty($height) ? ' height="' . $height . '"' : '') . (!empty($id) ? ' id="' . $id . '"' : '') . ' class="png_fix" />';

	return $image;
}

?>